package cc.glsn.v15.ga;

import java.util.Map;

public class State
{
	private int next_inst;

	private int r1;
	private int r2;
	private int opcode;
	private int oprand;

	private boolean terminated;

	private int mem[];



	public State(int sz)
	{
		this(new int[sz]);
	}

	public State(int mem[])
	{
		this.mem = mem;
		terminated=false;
	}

	public int getR1(){return r1;}
	public int getR2(){return r2;}
	public int getOpcode(){return opcode;}
	public int getOprand(){return oprand;}
	public boolean isTerminated(){return terminated;}
	

	public int getMemLen()
	{
		return mem.length;
	}

	public int convAddr(int addr)
	{
		if (addr < 0) addr = -addr;

		return (addr % mem.length);
	}

	public int getMem(int addr)
	{
		return mem[convAddr(addr)];
	}
	public int getMemAtR2()
	{
		return getMem(r2);
	}

	public void setMem(int addr, int v)
	{
		mem[convAddr(addr)]=v;
	}

	public void setR1(int r1)
	{
		this.r1 = r1;
	}
	public void setR2(int r2)
	{
		this.r2 = r2;
	}
	public void setNextInst(int n)
	{
		next_inst = n;
	}
	public void terminate()
	{
		terminated=true;
	}

	public void loadInst(Entity e)
	{
		e.setOp(this, next_inst);
		next_inst++;

	}
	public void setOp(int code, int rand)
	{
		opcode = code;
		oprand = rand;
	}

	public void runOp(Map<Integer, Op> im)
	{
		Op o = im.get(opcode);
		if (o != null)
		{
			o.doOp(this);
		}


	}


}

